<!--
Les directives commençant par une * sont dites "structurelles", ça
veut dire qu'elles vont modifier la structure du HTML.
Ici, on utilise le *ngFor qui va répéter l'élément html sur lequel
on le met autant de fois qu'il y a d'élément dans le tableau.
Les arguments qu'on lui donne ressemblent fortement à ce qu'on donnerait
dans un for..of, à savoir le nom de la variable disponible dans la boucle
et le nom du tableau à parcourir.
Si on veut récupérer l'index, il faudra mettre un ; et déclarer une
nouvelle variable à laquelle on assigne "index".
-->
<div *ngFor="let item of tableau; let key = index">
  {{key}} {{item}}
</div>

<!-- Le *ngIf va afficher ou non un élément dans le dom. A la différence
du hidden, un élément non affiché par le ngIf n'existe pas du tout
dans le dom (et donc son contenu n'est pas calculé par angular),
c'est une information à garder pour si jamais on teste si quelque
chose existe avant de l'utiliser dans l'élément par exemple.-->
<p *ngIf="tableau.length > 3">There are more than 3 elements</p>

<!-- Le ngModel va créer une relation bidirectionnelle entre un
input/select/textarea et une variable contenue dans le component.
Si la valeur de l'input change, la valeur de la variable change également
dans le component, et si on la change dans le component, elle change
dans l'input aussi -->
<input type="text" [(ngModel)]="texte">
<p>{{texte}}</p>

<!-- On ne peut mettre qu'une seule directive structurelle sur
un même élément, si on veut mettre un ngFor et un ngIf sur un même
élément, il faudra en fait le mettre sur deux élément différent.
exemple : 
<div *ngFor="..."> 
  <p *ngIf="..."></p> 
</div>
Cependant, dans certains cas, on ne voudra pas rajouter de nouveaux
éléments html qui pourraient casser notre style ou autre, à ce 
moment il faudra utiliser un élément spécial angular appelé ng-container
qui se traduira par aucune balise une fois compilé
exemple : 
<ng-container *ngFor="..."> 
  <p *ngIf="..."></p> 
</ng-container>
-->